
//______________ Variables globales de la App ______________

var nav = document.querySelector('#myNavigator'); // Navegador - Para hacer las transiciones de pantallas
var setTransperenciaMapa = false; // Variable que indica que la pantalla que se cargue ha de tener fondo transparente
var contenidoCargado = false; // Variable que controla que no se pueda raelizar ninguna acción antes de que se carguen los datos de los comercios
var idTransparente = ['comerciosCategoria.html','actividades.html','servicios.html','comercioSingle.html','actividadSingle.html','servicioSingle.html','rutaSingle.html']; // Array con las páginas que requieren fondo transparente por el Mapa
var fechaAgenda; // Variable que controla la fecha de la agenda
var imgMarkers = { 'marker':'./img/marker.png','user':'./img/marker.png','clusterBlue':"./img/cluster/blue.png",'clusterYellow':"./img/cluster/blue.png",'clusterRed':"./img/cluster/blue.png",'clusterPurple':"./img/cluster/blue.png" }; // Array para los Markers
var devicePlatform = ''; // Plataforma ( Se establece una vez inicializado el framework de Cordova )
var languageSTR = ''; F_La_SetSystemLanguage(); // Establecemos el idioma

//______________ Contenido global de la App ______________

var g_tiendas = {};
var g_actividades = {};
var g_servicios = {};
var g_tiendasCategoria = { '1':[],'2':[],'3':[],'4':[],'5':[],'6':[],'7':[],'8':[],'9':[],'10':[] };
var g_tiendasRuta = { '1':[],'2':[],'3':[],'4':[],'5':[],'6':[],'7':[],'8':[] };
var g_categorias = { 1:{"id":"1","nombre":F_La_GetText('categoria-1')},2:{"id":"2","nombre":F_La_GetText('categoria-2')},3:{"id":"3","nombre":F_La_GetText('categoria-3')},
					 4:{"id":"4","nombre":F_La_GetText('categoria-4')},5:{"id":"5","nombre":F_La_GetText('categoria-5')},6:{"id":"6","nombre":F_La_GetText('categoria-6')},
					 7:{"id":"7","nombre":F_La_GetText('categoria-7')},8:{"id":"8","nombre":F_La_GetText('categoria-8')},9:{"id":"9","nombre":F_La_GetText('categoria-9')},
					 10:{"id":"10","nombre":F_La_GetText('categoria-10')} };
var g_rutas = { 1:{"id":"1","nombre":F_La_GetText('ruta-1')},2:{"id":"2","nombre":F_La_GetText('ruta-2')},3:{"id":"3","nombre":F_La_GetText('ruta-3')},4:{"id":"4","nombre":F_La_GetText('ruta-4')},
				5:{"id":"5","nombre":F_La_GetText('ruta-5')},6:{"id":"6","nombre":F_La_GetText('ruta-6')},7:{"id":"7","nombre":F_La_GetText('ruta-7')},8:{"id":"8","nombre":F_La_GetText('ruta-8')} };
var g_informacion = {};

// Control de localización

var g_procesandoRuta = false;
var g_procesandoGeoloc = false;
var g_puntosIndicaciones = [];
var g_lineasIndicaciones = [];
var g_userLocation;
var g_userMarker;

// Parámetros de entrada de pantallas 

var p_comercios = {'categoria': '','vista': '' };
var p_comercioSingle = {'id': '','nombre': '','lat': 0,'long': 0};
var p_actividadSingle = {'id': '','nombre': '','lat': 0,'long': 0};
var p_servicioSingle = {'id': '','nombre': '','lat': 0,'long': 0};
var p_rutaSingle = {'id': '','nombre': ''};
var p_informacionSingle = '1';
var p_categoria = {'id': '','nombre': ''};
var p_evento = {'fechaKey':'','indice':''};

// Datos DIVA - DER

var g_arrayDERs = [];
var g_IdDERActual;
var g_arrayFacturas = [];

//_______________________ Inicialización ____________________

document.addEventListener('deviceready', function()
{
  $( document ).ready(function()
  {
    // Cordova & jQuery is now initialized. Have fun!
	
	devicePlatform = window.cordova.platformId;
	
	// *** INICIO ***
    
	var cargaShops = false;
	var cargaActivities = false;
	var cargaServices = false;
	
	F_Ep_GetJsonShops( function( myShops ){ g_tiendas = myShops['result']; cargaShops = true; checkReadyContent(); },
					   function( error ){ console.log('Error obteniendo las tiendas: ' + error); } );
	
	F_Ep_GetJsonActivities( function( myActivities ){ g_actividades = myActivities['result']; cargaActivities = true; checkReadyContent();  },
							function( error ){ console.log('Error obteniendo las actividades: ' + error); } );
	
	F_Ep_GetJsonServices( function( myServices ){ g_servicios = myServices['result']; cargaServices = true; checkReadyContent();  },
						  function( error ){ console.log('Error obteniendo los servicios: ' + error); } );
	
	function checkReadyContent()
	{
		if( cargaShops && cargaActivities && cargaServices )
		{
			// Dsitribuir las tiendas según categorías y rutas
			for( let i=0 ; i<g_tiendas.length ; i++ )
			{
				for( let j=0 ; j<g_tiendas[i]['categories'].length ; j++ )
				{
					if( g_tiendas[i]['categories'][j] <= 10 ) // Prevenir errores
						if( !g_tiendasCategoria[ g_tiendas[i]['categories'][j] ].includes( i ) ) // Prevenir Duplicidades
							g_tiendasCategoria[ g_tiendas[i]['categories'][j] ].push( i );
				}
				for( let j=0 ; j<g_tiendas[i]['rutas'].length ; j++ )
				{
					if( g_tiendas[i]['rutas'][j] <= 8 ) // Prevenir errores
						if( !g_tiendasRuta[ g_tiendas[i]['rutas'][j] ].includes( i ) ) // Prevenir Duplicidades
							g_tiendasRuta[ g_tiendas[i]['rutas'][j] ].push( i );
				}
			}
			
			// Carga de las preferencias de usuario
			F_Up_GetPrefs(function()
			{
				console.log("Got Prefs:", userPrefs);
				
				F_Turista_SetDatosConfiguracion();
				
				F_Agenda_SetFecha();
				
				F_Init_SeccionesRegistro();
				
				F_DER_CargarDERs();
				
				if( devicePlatform == 'Android' || devicePlatform == 'ios' )
					F_SetMarginNotches();
                
                F_InitImgMarkers();
				
				F_La_Traducir();
				
				// Desactivar el preloader
				$('#preloader').fadeOut(300);
				console.log("--- Ready ---");
                
			});
		}
	}
  });
}, false);

//_______________________ Listenedrs de eventos ____________________

document.addEventListener('init', function(event)
{
  var page = event.target;
  
  console.log('initPage', page.id);
  
  if( page.id === 'comercios.html' ){ 				N_Init_Comercios(); }
  else if( page.id === 'comercioSingle.html' ){ 	N_Init_ComercioSingle(); }
  else if( page.id === 'comerciosCategoria.html' ){ N_Init_ComerciosCategoria(); }
  else if( page.id === 'actividades.html' ){ 		N_Init_Actividades(); }
  else if( page.id === 'actividadSingle.html' ){ 	N_Init_ActividadSingle(); }
  else if( page.id === 'servicios.html' ){ 			N_Init_Servicios(); }
  else if( page.id === 'servicioSingle.html' ){ 	N_Init_ServicioSingle(); }
  else if( page.id === 'rutas.html' ){				N_Init_Rutas(); }
  else if( page.id === 'rutaSingle.html' ){			N_Init_RutaSingle(); }
  else if( page.id === 'informacionSingle.html' ){	N_Init_InformacionSingle(); }
  else if( page.id === 'registro.html' ){			N_Init_Registro(); }
  else if( page.id === 'agenda.html' ){				F_Agenda_SetFecha(); }
  
  //F_La_Traducir();
});

nav.addEventListener('postpush', function( event )
{
	console.log('PostPush!!', event );
	
	$('.page__background').css('background-color','rgb(239, 239, 244) !important;');
	if( idTransparente.includes(event.enterPage.id) )
	{
		console.log("Transparent!! ^^");
		setTimeout(function(){ $('.page__background').css('background-color','rgba(0,0,0,0) !important;'); }, 500);
		setTimeout(function(){ $('.page__background').css('background-color','rgba(0,0,0,0) !important;'); }, 1000);
		setTimeout(function(){ $('.page__background').css('background-color','rgba(0,0,0,0) !important;'); }, 1500);
		setTransperenciaMapa = false;
	}
	
	F_La_Traducir();
});

nav.addEventListener('prepop', function( event )
{
	console.log('PrePop!!', event );
	
	$('.page__background').css('background-color','rgb(239, 239, 244) !important;');
	if( idTransparente.includes(event.enterPage.id) )
	{
		setTimeout(function(){ $('.page__background').css('background-color','rgba(0,0,0,0) !important;'); }, 500);
		setTimeout(function(){ $('.page__background').css('background-color','rgba(0,0,0,0) !important;'); }, 1000);
		setTimeout(function(){ $('.page__background').css('background-color','rgba(0,0,0,0) !important;'); }, 1500);
	}
	
});
