
//***************************
var urlServerEndpoints = "https://madrid-shops.com/";
//***************************

// Obtiene el JSON ~1Mb de los servicios
function F_Ep_GetJsonServices( callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/getServicios.php",
	  type: "POST",
	  cache: false,
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Obtiene el JSON ~1Mb de las actividades
function F_Ep_GetJsonActivities( callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/getActivities.php",
	  type: "POST",
	  cache: false,
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Obtiene el JSON ~1Mb de las tiendas
function F_Ep_GetJsonShops( callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/getShops.php",
	  type: "POST",
	  cache: false,
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Login de usuario
function F_Ep_Login( mail, pass, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/loginTourist.php",
	  type: "GET",
	  cache: false,
	  data: {
		"mail": mail,
		"pass": pass
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Registro de usuario
function F_Ep_Register( nombre, mail, pass, f_nacimiento, numPasaporte, f_llegada, vueloLlegada, f_salida, vueloSalida, paisOrigen, IdEmpresaTaxFree, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/registerTourist.php",
	  type: "GET",
	  cache: false,
	  data: {
		  "nombre": nombre,
		  "mail": mail,
		  "pass": pass,
		  "f_nacimiento": f_nacimiento,
		  "numPasaporte": numPasaporte,
		  "f_llegada": f_llegada,
		  "vueloLlegada": vueloLlegada,
		  "f_salida": f_salida,
		  "vueloSalida": vueloSalida,
		  "paisOrigen": paisOrigen,
		  "IdEmpresaTaxFree": IdEmpresaTaxFree
	  },
	  success: function(response)
	  {
		console.log( response );
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Registro de usuario
function F_Ep_EditTourist( callback )
{
	var clave = "Madiva2019";
	var IdTurista = userPrefs['turista']['IdTurista'];
	var nombre = userPrefs['turista']['nombre'];
	var mail = userPrefs['turista']['mail'];
	var pass = userPrefs['turista']['pass'];
	var f_nacimiento = userPrefs['turista']['fechaNacimiento'];
	if( typeof(f_nacimiento) != 'undefined' ) f_nacimiento = f_nacimiento.replace('-','').replace('-','');
	var numPasaporte = userPrefs['turista']['numPasaporte'];
	var f_llegada = userPrefs['turista']['fechaLlegada'];
	if( typeof(f_llegada) != 'undefined' ) f_llegada = f_llegada.replace('-','').replace('-','');
	var vueloLlegada = userPrefs['turista']['vueloLlegada'];
	var f_salida = userPrefs['turista']['fechaPartida'];
	if( typeof(f_salida) != 'undefined' ) f_salida = f_salida.replace('-','').replace('-','');
	var vueloSalida = userPrefs['turista']['vueloPartida'];
	var paisOrigen = userPrefs['turista']['paisOrigen'];
	var IdEmpresaTaxFree = userPrefs['turista']['modoReembolso'];
	
	$.ajax({
	  url: urlServerEndpoints + "json/setTouristData.php",
	  type: "GET",
	  cache: false,
	  data: {
		  "clave": "Madiva2019",
		  "IdTurista": IdTurista,
		  "nombre": nombre,
		  "mail": mail,
		  "pass": pass,
		  "f_nacimiento": f_nacimiento,
		  "numPasaporte": numPasaporte,
		  "f_llegada": f_llegada,
		  "vueloLlegada": vueloLlegada,
		  "f_salida": f_salida,
		  "vueloSalida": vueloSalida,
		  "paisOrigen": paisOrigen,
		  "IdEmpresaTaxFree": IdEmpresaTaxFree
	  },
	  success: function(response)
	  {
		console.log( 'STD:', response );
		callback( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		console.log( "Error enviando datos", errorThrown );
	  }
	});
}

// Obtencion de los DER del turista
function F_Ep_GetDERs( IdTurista, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/getTouristDERs.php",
	  type: "GET",
	  cache: false,
	  data: {
		"IdTurista": IdTurista
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Obtencion de los DER del turista
function F_Ep_GetFacturas( IdTurista, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/getTouristBills.php",
	  type: "GET",
	  cache: false,
	  data: {
		"IdTurista": IdTurista
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Solicitud de código de restablecimiento
function F_Ep_SolocitarReseteo( mail, idioma, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/sendResetCode.php",
	  type: "GET",
	  cache: false,
	  data: {
		"mail": mail
	  },
	  success: function(response)
	  {
		console.log(response);
		var res = JSON.parse(response);
		callback_Ok( res['message'] );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Solicitud de pago de un DER al comercio
function F_Ep_SolicitarReembolso( IdDER, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/requestPayment.php",
	  type: "GET",
	  cache: false,
	  data: {
		"IdDER": IdDER
	  },
	  success: function(response)
	  {
		console.log(response);
		var res = JSON.parse(response);
		callback_Ok( res['message'] );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Obtiene las empresas de Tax-free asociadas
function F_Ep_GetJsonEmpresasTaxFree( callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/getTaxFreeEntities.php",
	  type: "POST",
	  cache: false,
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Actualiza la opción de TaxFree del turista
function F_Ep_ActualizarEntidadTaxFree( IdTurista, nuevoValor, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "json/setTouristEntity.php",
	  type: "GET",
	  cache: false,
	  data: {
		"IdTurista": IdTurista,
		"nuevoValor": nuevoValor,
		"clave": "Madiva2019"
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}


//------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------
//------------------------------------------------------------------------------------------------------------------------

/*
// Obtiene los datos de usuario guardados
function F_Ep_GetInfoUsuario( in_userPrefs, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "endpoints/user-login.php",
	  type: "POST",
	  cache: false,
	  data: {
		"userPrefs": in_userPrefs
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Guarda los cambios realizados en la cuenta desde la App
function F_Ep_ModificarCuenta( in_userPrefs, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "endpoints/user-modificar.php",
	  type: "POST",
	  cache: false,
	  data: {
		"userPrefs": in_userPrefs
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

// Elimina una cuenta
function F_Ep_EliminarCuenta( mail, pass, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "endpoints/user-eliminar.php",
	  type: "POST",
	  cache: false,
	  data: {
		"mail": mail,
		"pass": pass
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

//------------------------------------------------------------------------------------------------------------------------

// Login de usuario a través de RRSS
function F_Ep_LoginRRSS( mail, nombreRedSocial, token, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "endpoints/user-eliminar.php",
	  type: "POST",
	  cache: false,
	  data: {
		"mail": mail,
		"nombreRedSocial": nombreRedSocial,
		"token": token
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}

//------------------------------------------------------------------------------------------------------------------------

// Elimina una cuenta
function F_Ep_ObtenerDER( in_userPrefs, callback_Ok, callback_Ko )
{
	$.ajax({
	  url: urlServerEndpoints + "endpoints/DER-obtener.php",
	  type: "POST",
	  cache: false,
	  data: {
		"userPrefs": in_userPrefs
	  },
	  success: function(response)
	  {
		callback_Ok( response );
	  },
	  error: function(jqXHR, textStatus, errorThrown)
	  {
		callback_Ko( errorThrown );
	  }
	});
}
*/
//------------------------------------------------------------------------------------------------------------------------
