
	// Including Scripts
	function F_LoadScript( path, callback )
	{
		var scriptEndpoints = document.createElement('script');
		scriptEndpoints.src = path;
		$("body").append(scriptEndpoints);
		scriptEndpoints.onload = function(){ callback(); }
	}
	
	// Including Scripts
	function F_InitImgMarkers()
	{
		if( devicePlatform == 'ios' )
		{
			// En caso de ser iOS, cargamos de forma externa el contenido de los mapas.
			imgMarkers = {
				'marker':'https://madrid-shops.com/appImages/marker.png',
				'user':'https://madrid-shops.com/appImages/markerUser.png',
				'markerUser':'https://madrid-shops.com/appImages/markerUser.png',
				'clusterBlue':'https://madrid-shops.com/appImages/cluster/blue.png',
			    'clusterYellow':'https://madrid-shops.com/appImages/cluster/yellow.png',
			    'clusterRed':'https://madrid-shops.com/appImages/cluster/red.png',
			    'clusterPurple':'https://madrid-shops.com/appImages/cluster/purple.png' }; // Array para los Markers
		}
	}
	
    // Notches padding
    function F_SetMarginNotches()
    {
        cutout.has().then(function( result ){
            if( result )
            {
                $('body').css('margin-top','40px');
                $('body').css('height','calc(100%)');
            }
        });
    }

	// Change
	function F_App_Perfil_Change( elem )
	{
		var key = $(elem).attr('id').substr(7);
		userPrefs['turista'][key] = $(elem).val();
		
		F_Up_SavePrefs( function( res ){ console.log('datos guardados', res); });
		F_Turista_EnviarDatosConfiguracion( function( res ){ console.log('Res', res); } );
	}
	
	// Sign-Up
	function F_User_SingUp()
	{
		var mail = $('#in_mail').val();
		var pass = $('#in_pass').val();
		
		F_Ep_Register(
			$('#in_reg_name').val(),
			$('#in_reg_mail').val(),
			$('#in_reg_pass').val(),
			$('#in_reg_f_nacimiento').val(),
			$('#in_reg_pasaporte').val(),
			$('#in_reg_f_llegada').val(),
			'',
			$('#in_reg_f_salida').val(),
			'',
			$('#in_reg_paisOrigen').val(),
			'Comercio',
			function( result )
			{
				result = JSON.parse(result);
				
				if( result["error"] == 0 )
				{
					userPrefs['loggedIn'] = true;
					userPrefs['turista'] = result["turista"];
					F_Up_SavePrefs( function(){
						ons.notification.toast( F_La_GetText("Login_Ep_Ok"), { timeout: 2000 } );
						setTimeout(function(){ window.location.href = "index.html"; }, 2000);
					});
				}
				else
				{
					console.log("Login_Ep_Error_" + result["error"]);
					ons.notification.alert( F_La_GetText("Login_Ep_Error_" + result["error"] ), { timeout: 2000 } );
				}
			},
			function( error ){
				console.log( error );
			}
		);
	}
	
	// Log-In
	function F_User_Login()
	{
		var mail = $('#in_mail').val();
		var pass = $('#in_pass').val();
		
		F_Ep_Login(
			mail,
			pass,
			function( result )
			{
				result = JSON.parse(result);
				
				if( result["error"] == 0 )
				{
					userPrefs['loggedIn'] = true;
					
					console.log( "TTT", result['turista'] );
					
					userPrefs['turista']['IdTurista'] = result['turista']["IdTurista"];
					userPrefs['turista']['nombre'] = result['turista']["traveler_name"];
					userPrefs['turista']['mail'] = result['turista']["traveler_email"];
					userPrefs['turista']['vueloLlegada'] = result['turista']["traveler_transport_arrival_number"];
					userPrefs['turista']['vueloPartida'] = result['turista']["traveler_transport_depart_number"];
					userPrefs['turista']['paisOrigen'] = result['turista']["traveler_country"];
					userPrefs['turista']['numPasaporte'] = result['turista']["traveler_passport"];
					userPrefs['turista']['modoReembolso'] = result["turista"]["IdEmpresaTaxFree"];
					
					if( typeof(result["turista"]["traveler_birthdate"]) != 'undefined' && result["turista"]["traveler_birthdate"] != '' )
						userPrefs['turista']['fechaNacimiento'] = result["turista"]["traveler_birthdate"].substr(0,4) + '-' + result["turista"]["traveler_birthdate"].substr(4,2) + '-' + result["turista"]["traveler_birthdate"].substr(6,2);
					
					if( typeof(result["turista"]["traveler_transport_arrival_date"]) != 'undefined' && result["turista"]["traveler_transport_arrival_date"] != '' )
						userPrefs['turista']['fechaLlegada'] = result["turista"]["traveler_transport_arrival_date"].substr(0,4) + '-' + result["turista"]["traveler_transport_arrival_date"].substr(4,2) + '-' + result["turista"]["traveler_transport_arrival_date"].substr(6,2);
					
					if( typeof(result["turista"]["traveler_transport_depart_date"]) != 'undefined' && result["turista"]["traveler_transport_depart_date"] != '' )
						userPrefs['turista']['fechaPartida'] = result["turista"]["traveler_transport_depart_date"].substr(0,4) + '-' + result["turista"]["traveler_transport_depart_date"].substr(4,2) + '-' + result["turista"]["traveler_transport_depart_date"].substr(6,2);
					
					F_Turista_SetDatosConfiguracion();
					
					F_Up_SavePrefs( function(){
						ons.notification.toast( F_La_GetText("Login_Ep_Ok"), { timeout: 2000 } );
						setTimeout(function(){ window.location.href = "index.html"; }, 2000);
					});
				}
				else
				{
					console.log("Login_Ep_Error_" + result["error"]);
					ons.notification.alert( F_La_GetText("Login_Ep_Error_" + result["error"] ), { timeout: 2000 } );
				}
			},
			function( error ){
				console.log( error );
			}
		);
	}
	
	// Logout
	function F_User_Logout()
	{
		console.log('ckeck');
		userPrefs['loggedIn'] = false;
		userPrefs['mostrarIntro'] = true;
		userPrefs['turista'] = {};
		
		F_Up_SavePrefs( function(){
			ons.notification.toast( F_La_GetText("Logout_Ok"), { timeout: 2000 } );
			setTimeout(function(){ window.location.href = "index.html"; }, 2000);
		});
	}
	
	// Forgot
	function F_Btn_SolicitarReseteo()
	{
		F_Ep_SolocitarReseteo( $('#modalRestablecer_mail').val(), "1",
			function( response )
			{
				console.log("Success", response );
				$('#textoResultadoSolicitudReseteo').html(response);
				//document.querySelector('ons-modal').hide();
			},
			function( response )
			{
				console.log("Fail", response );
				$('#textoResultadoSolicitudReseteo').html(response);
				//document.querySelector('ons-modal').hide();
			}
		);
	}
	
	// Obtener el código con "padding" de ceros
	function F_DER_GetCodigoTurista( in_IdTurista )
	{
		function paddy(num, padlen, padchar) {
			var pad_char = typeof padchar !== 'undefined' ? padchar : '0';
			var pad = new Array(1 + padlen).join(pad_char);
			return (pad + num).slice(-pad.length);
		}
		
		return "MAD" + paddy(in_IdTurista,5,"0");
	}
	
	//______________ Agenda ______________
	
	function F_Agenda_SetDiaAnterior()
	{
		var nuevaFecha = new Date( fechaAgenda['año'], fechaAgenda['mes']-1, fechaAgenda['dia'], 12, 12, 12 );
		
		nuevaFecha.setDate(nuevaFecha.getDate()-1);
		
		fechaAgenda = { 'indice':nuevaFecha.toJSON().substr(0,10),'dia':nuevaFecha.getDate(),'mes':nuevaFecha.getMonth()+1,'año':nuevaFecha.getFullYear() };
		
		F_Agenda_SetFecha();
	}
	
	function F_Agenda_SetDiaSiguiente()
	{
		var nuevaFecha = new Date( fechaAgenda['año'], fechaAgenda['mes']-1, fechaAgenda['dia'], 12, 12, 12  );
		
		nuevaFecha.setDate(nuevaFecha.getDate()+1);
		
		fechaAgenda = { 'indice':nuevaFecha.toJSON().substr(0,10), 'dia':nuevaFecha.getDate(),'mes':nuevaFecha.getMonth()+1,'año':nuevaFecha.getFullYear() };
		
		F_Agenda_SetFecha();
	}
	
	// Establecer datos de Agenda del día actual
	function F_Agenda_SetFecha()
	{
		$('#agenda_timeline').html('');
		
		if( typeof(fechaAgenda) == 'undefined' )
		{
			var ref = new Date(); // Referencia para que no salte a un día anterior en caso de se las 00:00.
			var d = new Date( ref.getFullYear(), ref.getMonth(), ref.getDate(), 12, 12, 12);
			
			fechaAgenda = { 'indice':d.toJSON().substr(0,10),'dia':d.getDate(),'mes':d.getMonth()+1,'año':d.getFullYear() };
		}
		
		if( typeof( userPrefs['agenda'] ) == 'undefined' )
		{
			userPrefs['agenda'] = {};
		}
		
		var fechaKey = fechaAgenda['indice'];
		$('#agenda_fecha').html( fechaAgenda['dia'] + ' del ' + fechaAgenda['mes'] + ' de ' + fechaAgenda['año'] );
		
		var fechaActual = new Date();
		
		if( fechaActual.getDate() == fechaAgenda['dia'] && fechaActual.getMonth()+1 == fechaAgenda['mes'] && fechaActual.getFullYear() == fechaAgenda['año'] )
		{
			$('#agenda_fecha').css('font-weight', '800');
		}
		else
		{
			$('#agenda_fecha').css('font-weight', '100');
		}
		
		$('#tabIconAgenda').attr('badge','');
		if( typeof( userPrefs['agenda'][fechaKey] ) != 'undefined' && Object.keys(userPrefs['agenda'][fechaKey]).length > 0 )
		{
			if( fechaActual.getDate() == fechaAgenda['dia'] && fechaActual.getMonth()+1 == fechaAgenda['mes'] && fechaActual.getFullYear() == fechaAgenda['año'] )
			{
				$('#tabIconAgenda').attr('badge',Object.keys(userPrefs['agenda'][fechaKey]).length);
			}
			
			for( let i=0 ; i<Object.keys(userPrefs['agenda'][fechaKey]).length ; i++ )
			{
				var evento = userPrefs['agenda'][fechaKey][i];
				
				var fechaHora = new Date( evento['fecha'] + " " + evento['hora'] );
				
				var icono = '';
				if( evento['tipo'] == 'Tienda' ) icono = '<i class="fa fa-user"></i>';
				
				//<i class="fas fa-store-alt"></i>
				
				$('#agenda_timeline').addClass('timeline-list');
				
				$('#agenda_timeline').append('                                             		\
				<li onclick="F_Agenda_PopUpEditarEvento(\'' + fechaKey + '\',\'' + i + '\');">  \
					<div class="timeline-icon">' + icono + '</div>     					   		\
					<div class="timeline-time">' + formatAMPM( fechaHora ) + '</div> 	   		\
					<div class="timeline-content">                                         		\
						<strong>' + evento['titulo'] + '</strong></p>                      		\
						<p class="push-bit">' + evento['descripcion'] + '</p>       	   		\
					</div>                                                                 		\
				</li>                                                                      		\
				');
			}
		}
		else
		{
			$('#agenda_timeline').removeClass('timeline-list');
			$('#agenda_timeline').html('<p id="agenda_TextoSinActividades">No hay actividades para este día.<p>');
		}
	}
	
	// Establecer datos de Agenda del día actual
	function F_Agenda_SeleccionarFecha( valFecha )
	{
		fechaAgenda = { 'indice':valFecha, 'dia':parseInt(valFecha.substr(8)),'mes':parseInt(valFecha.substr(5,7)),'año':parseInt(valFecha.substr(0,4)) };
		F_Agenda_SetFecha();
	}
	
	function F_Agenda_PopUpNuevoEvento()
	{
		var modal = document.querySelector('#modalEvento');
		
		var ref = new Date(); // Referencia para que no salte a un día anterior en caso de se las 00:00.
		var d = new Date( ref.getFullYear(), ref.getMonth(), ref.getDate(), 12, 12, 12);
		
		$('#evento_fecha').val( d.toJSON().substr(0,10) );
		$('#evento_hora').val( '12:00' );
		
		var id = nav.pages[ (nav.pages.length - 1) ].id;
		
		$('#evento_tipo option').removeAttr('selected');
		
		var titulo = '';
		if( id == "comercioSingle.html" ) {
			titulo = 'Visitar ' + p_comercioSingle['name'];
			$('#evento_tipo option[value="Tecnico"]').attr('selected',true);
		}
		else if( id == "actividadSingle.html" ) {
			titulo = 'Ver ' + p_actividadSingle['name'];
			$('#evento_tipo option[value="Actividad"]').attr('selected',true);
		}
		else if( id == "servicioSingle.html" ) {
			titulo = 'Ir a ' + p_servicioSingle['name'];
			$('#evento_tipo option[value="Servicio"]').attr('selected',true);
		}
		else
		{
			titulo = "Actividad";
			$('#evento_tipo option[value="Otro"]').attr('selected',true);
		}
		
		$('#evento_titulo').val( titulo );
		
		$('#modalEventoContenidoPieEditar').css('display','none');
		$('#modalEventoContenidoPieCrear').css('display','block');
		
		modal.show();
	}
	
	function F_Agenda_CrearEvento()
	{
		var modal = document.querySelector('#modalEvento');
		var evento = {};
		
		var fecha = $('#evento_fecha').val();
		var hora = $('#evento_hora').val();
		
		if( $('#evento_fecha').val() == '' ){ ons.notification.toast('Es necesario seleccionar una fecha', { timeout: 1000, animation: 'fall' });  }
		else if( $('#evento_hora').val() == '' ){ ons.notification.toast('Es necesario seleccionar una fecha', { timeout: 1000, animation: 'fall' });  }
		else if( $('#evento_titulo').val() == '' ){ ons.notification.toast('Es necesario seleccionar una fecha', { timeout: 1000, animation: 'fall' });  }
		else
		{
			evento['tipo'] = $('#evento_tipo').val();
			evento['titulo'] = $('#evento_titulo').val();
			evento['descripcion'] = $('#evento_descripcion').val();
			
			evento['fechaHora'] = new Date( fecha + ' ' + hora );
			
			evento['fecha'] = fecha;
			evento['hora'] = hora;
			
			if( typeof(userPrefs['agenda'][fecha]) == 'undefined' )
				userPrefs['agenda'][fecha] = [];
			
			userPrefs['agenda'][fecha].push(evento);
			
			F_Up_SavePrefs( function( res ){ modal.hide(); F_Agenda_SetFecha(); ons.notification.toast('Evento creado en la agenda', { timeout: 1000, animation: 'fall' }); });
		}
	}
	
	function F_Agenda_PopUpEditarEvento( fechaKey , indice )
	{
		var modal = document.querySelector('#modalEvento');
		p_evento = {'fechaKey':fechaKey,'indice':indice};
		
		var evento = userPrefs['agenda'][fechaKey][indice];
		
		$('#evento_titulo').val( evento['titulo'] );
		$('#evento_tipo').val( evento['tipo'] );
		$('#evento_descripcion').val( evento['descripcion'] );
		
		$('#evento_fecha').val( evento['fecha'] );
		$('#evento_hora').val( evento['hora'] );
		
		console.log("setting", evento);
		
		$('#modalEventoContenidoPieCrear').css('display','none');
		$('#modalEventoContenidoPieEditar').css('display','block');
		
		modal.show();
	}
	
	function F_Agenda_EditarEvento()
	{
		var modal = document.querySelector('#modalEvento');
		var evento = {};
		
		var fecha = $('#evento_fecha').val();
		var hora = $('#evento_hora').val();
		
		if( $('#evento_fecha').val() == '' ){ ons.notification.toast('Es necesario seleccionar una fecha', { timeout: 1000, animation: 'fall' });  }
		else if( $('#evento_hora').val() == '' ){ ons.notification.toast('Es necesario seleccionar una fecha', { timeout: 1000, animation: 'fall' });  }
		else if( $('#evento_titulo').val() == '' ){ ons.notification.toast('Es necesario seleccionar una fecha', { timeout: 1000, animation: 'fall' });  }
		else
		{
			evento['tipo'] = $('#evento_tipo').val();
			evento['titulo'] = $('#evento_titulo').val();
			evento['descripcion'] = $('#evento_descripcion').val();
			
			evento['fechaHora'] = new Date( fecha + ' ' + hora );
			
			evento['fecha'] = fecha;
			evento['hora'] = hora;
			
			userPrefs['agenda'][fecha][p_evento['indice']] = evento;
			
			F_Up_SavePrefs( function( res ){ modal.hide(); F_Agenda_SetFecha(); ons.notification.toast('Evento actualizado', { timeout: 1000, animation: 'fall' }); });
		}
	}
	
	function F_Agenda_EliminarEvento()
	{
		var modal = document.querySelector('#modalEvento');
		
		userPrefs['agenda'][p_evento['fechaKey']].splice(p_evento['indice']);
		
		F_Up_SavePrefs( function( res ){ modal.hide(); F_Agenda_SetFecha(); ons.notification.toast('Evento eliminado', { timeout: 1000, animation: 'fall' }); });
	}
	
	// **************** RUTAS ****************
	
	function CalcularRuta( myMap, routeType, locationFin )
	{
		if( !g_procesandoRuta )
		{
			g_procesandoRuta = true;
			
			var directionsService = new google.maps.DirectionsService();
			
			var request = {
				origin: g_userLocation,
				destination: locationFin,
				travelMode: routeType
			};
			
			var bounds = new plugin.google.maps.LatLngBounds();
			  bounds.extend( g_userLocation );
			  bounds.extend( locationFin );
			  
			  myMap.animateCamera({
				//'tilt': 30,
				'target' : bounds,
				'bearing': 0,
				'duration': 2000
			  });
			
			directionsService.route(request, function (response, status)
			{
				if (status == google.maps.DirectionsStatus.OK)
				{
					for( let i=0 ; i<g_puntosIndicaciones.length ; i++ ){ g_puntosIndicaciones[i].remove(); } g_puntosIndicaciones = [];
					for( let i=0 ; i<g_lineasIndicaciones.length ; i++ ){ g_lineasIndicaciones[i].remove(); } g_lineasIndicaciones = [];
					if( typeof( g_userMarker ) != 'undefined'  ) g_userMarker.remove();
					
					var stepsResponse = response['routes'][0]['legs'][0]['steps'];
					for( var i=0 ; i<stepsResponse.length ; i++)
					{
						var puntos = [];
						var step = stepsResponse[i];
						var l_color = '#000000';
						var l_width = 3;
						
						if( step['travel_mode'] == 'WALKING' )
						{
							if( i == 0 )
								var icon = './img/markerUser.png';
							else
								var icon = "https://maps.gstatic.com/mapfiles/transit/iw2/6/walk.png";
							
							l_color = '#FFBB55BB';
							l_width = 3;
							
							if( i == 0 )
							{
								var markerTransbordo = myMap.addMarker({
								  title: stepsResponse[i]['instructions'],
								  position: {
									lat: stepsResponse[i]['lat_lngs'][0].lat(),
									lng: stepsResponse[i]['lat_lngs'][0].lng()
								  },
								  animation: plugin.google.maps.Animation.BOUNCE,
								  icon: icon
								});
								
								g_puntosIndicaciones.push(markerTransbordo);
							}
						}
						else if( step['travel_mode'] == 'TRANSIT' )
						{
							l_color = '#FF55BBBB';
							l_width = 4;
							
							var linea = stepsResponse[i]['transit']['line'];
							
							var markerTransbordo = myMap.addMarker({
							  title: "" + stepsResponse[i]['instructions'] + "" + "\n" +
									 linea['name'] + "\n" +
									 "Dirección: " + stepsResponse[i]['transit']['headsign'] + "\n" +
									 "Paradas: " + stepsResponse[i]['transit']['num_stops'],
							  position: {
								lat: stepsResponse[i]['lat_lngs'][0].lat(),
								lng: stepsResponse[i]['lat_lngs'][0].lng()
							  },
							  animation: plugin.google.maps.Animation.BOUNCE,
							  icon: stepsResponse[i]['transit']['line']['vehicle']['icon']
							});
							g_puntosIndicaciones.push(markerTransbordo);
						}
						else if( step['travel_mode'] == 'DRIVING' )
						{
							l_color = '#FF5555BB';
							l_width = 4;
							
							if( i == 0 )
							{
								var markerTransbordo = myMap.addMarker({
								  title: stepsResponse[i]['instructions'],
								  position: {
									lat: stepsResponse[i]['lat_lngs'][0].lat(),
									lng: stepsResponse[i]['lat_lngs'][0].lng()
								  },
								  animation: plugin.google.maps.Animation.BOUNCE,
								  icon: "https://maps.gstatic.com/mapfiles/transit/iw2/6/drive.png"
								  //'icon': './img/dot.png'
								});
								
								g_puntosIndicaciones.push(markerTransbordo);
							}
						}
						
						for( var j=0 ; j<stepsResponse[i]['lat_lngs'].length ; j++ )
						{
							puntos.push( {lat:stepsResponse[i]['lat_lngs'][j].lat(), lng:stepsResponse[i]['lat_lngs'][j].lng()} );
						}
						
						var myPolyline = myMap.addPolyline({
						  'points': puntos,
						  'color' : l_color,
						  'width': l_width,
						  'geodesic': false
						});
						g_lineasIndicaciones.push( myPolyline );
					}
					
					g_procesandoRuta = false;
				}
				else
				{
					ons.notification.alert("Directions Request from " + g_userLocation.toUrlValue(6) + " to " + locationFin.toUrlValue(6) + " failed: " + status);
					g_procesandoRuta = false;
				}
			});
		}
	}
	
	function Geolocalizar( myMap, locationRef, callback )
	{
		if( !g_procesandoGeoloc && !g_procesandoRuta )
		{
			g_procesandoGeoloc = true;
			
			for( let i=0 ; i<g_puntosIndicaciones.length ; i++ ){ g_puntosIndicaciones[i].remove(); } g_puntosIndicaciones = [];
			for( let i=0 ; i<g_lineasIndicaciones.length ; i++ ){ g_lineasIndicaciones[i].remove(); } g_lineasIndicaciones = [];
			if( typeof( g_userMarker ) != 'undefined'  ) g_userMarker.remove();
			
			// Get the current device location "without map"
			var option = {
			  enableHighAccuracy: true // use GPS as much as possible
			};
			
			plugin.google.maps.LocationService.getMyLocation(option, function(location)
			{
			  g_userLocation = location.latLng;
			  
			  if( typeof(g_userMarker) != 'undefined' )
				  g_userMarker.remove();
			  
			  // Add a marker
			  g_userMarker = myMap.addMarker({
				title: 'Tu ubicación',
				position: location.latLng,
				'icon': './img/markerUser.png'
			  });
			  
			  var bounds = new plugin.google.maps.LatLngBounds();
			  bounds.extend( location.latLng );
			  bounds.extend( locationRef );
			  
			  myMap.animateCamera({
				'target' : bounds,
				'bearing': 0,
				'duration': 2000
			  });
			  
			  callback();
			  g_procesandoGeoloc = false;
			},
			function(error){
			  console.log( error );
			  ons.notification.alert('Geolocalización desactivada o no disponible',{title:'Error'});
			  callback();
			  g_procesandoGeoloc = false;
			});
		}
	}
	
	// --- MADIVA - DERs ---
	
	function F_DER_GetCodigoTurista( in_IdTurista )
	{
		function paddy(num, padlen, padchar) {
			var pad_char = typeof padchar !== 'undefined' ? padchar : '0';
			var pad = new Array(1 + padlen).join(pad_char);
			return (pad + num).slice(-pad.length);
		}
		
		return "MAD" + paddy(in_IdTurista,5,"0");
	}
	
	function F_DER_CargarDERs()
	{
		if( userPrefs['loggedIn'] && userPrefs['turista'] )
		{
		  var DER_IdTurista = userPrefs['turista']['IdTurista'];
		  var numDocumentosTotal = 0;
		  
		  function CheckDERs( callback )
		  {
			  F_Ep_GetDERs( DER_IdTurista, function( jsonDERs )
			  {
				g_arrayDERs = JSON.parse(jsonDERs);
				
				var i, myDER, base1, base2, total1, total2;
				
				$("#DER_onsListDERs").html("<ons-list-header class='center'>" + F_La_GetText('taxfree-listadoDocumentos') + "</ons-list-header>");
				$("#DER_codigoTurista").html( F_DER_GetCodigoTurista(DER_IdTurista) );
				
				if( g_arrayDERs.length > 0 )
				{
					for( i=0 ; i<g_arrayDERs.length ; i++ )
					{
						myDER = g_arrayDERs[i];
						
						base2 = myDER['total_taxable_base'].toFixed(2).toString().substr(myDER['total_taxable_base'].toFixed(2).toString().indexOf('.'));
						total2 = myDER['total_iva'].toFixed(2).toString().substr(myDER['total_iva'].toFixed(2).toString().indexOf('.'));
						base1 = myDER['total_taxable_base'].toFixed(2).toString().substr(0, myDER['total_taxable_base'].toFixed(2).toString().indexOf('.'));
						total1 = myDER['total_iva'].toFixed(2).toString().substr(0, myDER['total_iva'].toFixed(2).toString().indexOf('.'));
						
						$("#DER_onsListDERs").append(" " +
							"<ons-list-item id='button-DER-Single-" + i + "' class='' data-numDER='" + i + "' modifier='chevron' tappable>" +
							  "<ons-row class='tax-element'>" +
								"<ons-col width='50%'>" +
									"<span class='tax-title'>" + myDER['tienda']['establishment_tradename'] + "</span><br>" +
									"<span class='tax-id'><span class='tax-ilr'>I.L.R. </span>" + myDER['invoice_number'] + "</span>" +
								"</ons-col>" +
								"<ons-col width='25%'>" +
									"<div class='tax-sello'>D.E.R.</div>" +
								"</ons-col>" +
								"<ons-col width='25%'>" +
									"<span class='tax-money total'>" + base1 + "</span><span class='tax-cents'>" + base2 + "</span><span class='tax-currency'>€</span><br>" +
									"<span class='tax-money'>" + total1 + "</span><span class='tax-cents'>" + total2 + "</span><span class='tax-currency'>€</span>" +
								"</ons-col>" +
							  "</ons-row>" +
							"</ons-list-item>"
						);
					}
				}
				$("[id^='button-DER-Single']").click( function()
				{
					F_DER_loadDERSingle( $(this).attr("data-numDER") );
				});
				callback();
			  },
			  function( error )
			  {
				console.log( error );
				callback();
			  });
		  }
		  
		  function CheckFacturas( callback )
		  {
			  F_Ep_GetFacturas( DER_IdTurista, function( jsonFacturas )
			  {
				g_arrayFacturas = JSON.parse(jsonFacturas);
				
				var i, myDER, base1, base2, total1, total2;
				
				$("#onsListFacturas").html("<ons-list-header class='center'>" + F_La_GetText('taxfree-listadoFacturas') + "</ons-list-header>");
				$("#codigoTurista").html(F_DER_GetCodigoTurista(DER_IdTurista));
				
				if( g_arrayFacturas.length > 0 )
				{
					for( i=0 ; i<g_arrayFacturas.length ; i++ )
					{
						myFactura = g_arrayFacturas[i];
						
						base2 = myFactura['total_taxable_base'].toFixed(2).toString().substr(myFactura['total_taxable_base'].toFixed(2).toString().indexOf('.'));
						total2 = myFactura['total_iva'].toFixed(2).toString().substr(myFactura['total_iva'].toFixed(2).toString().indexOf('.'));
						base1 = myFactura['total_taxable_base'].toFixed(2).toString().substr(0, myFactura['total_taxable_base'].toFixed(2).toString().indexOf('.'));
						total1 = myFactura['total_iva'].toFixed(2).toString().substr(0, myFactura['total_iva'].toFixed(2).toString().indexOf('.'));
						
						var myImg = "";
						if( myFactura['etx']['logoBase64'].length > 10 )
							myImg = myFactura['etx']['logoBase64'];
						
						$("#onsListFacturas").append(" " +
							"<ons-list-item id='button-Factura-Single-" + i + "' class='' data-numFactura='" + i + "' modifier='chevron' tappable>" +
							  "<ons-row class='tax-element'>" +
								"<ons-col width='50%'>" +
									"<span class='tax-title'>" + myFactura['tienda']['establishment_tradename'] + "</span><br>" +
									"<span class='tax-id'>" + myFactura['etx']['nombre'] + "</span>" +
								"</ons-col>" +
								"<ons-col width='25%'>" +
									"<img style='max-height:30px;' src=" + myImg + ">" +
								"</ons-col>" +
								"<ons-col width='25%'>" +
									"<span class='tax-money total'>" + base1 + "</span><span class='tax-cents'>" + base2 + "</span><span class='tax-currency'>€</span><br>" +
									"<span class='tax-money'>" + total1 + "</span><span class='tax-cents'>" + total2 + "</span><span class='tax-currency'>€</span>" +
								"</ons-col>" +
							  "</ons-row>" +
							"</ons-list-item>"
						);
					}
				}
				$("[id^='button-Factura-Single']").click( function()
				{
					fn.loadFacturaSingle( $(this).attr("data-numFactura") );
				});
				callback();
			  },
			  function( error )
			  {
				console.log( error );
				callback();
			  });
		  }
		  CheckDERs(function(){
			  CheckFacturas(function(){
				  if( g_arrayDERs.length == 0 )
					$("#DERvacio").show();
			  })
		  })
		}
		/*
		else
		{
			ons.notification.confirm({
				title: F_La_GetText('info-taxfree'),
				message: F_La_GetText('info-necesario-Registro'),
				buttonLabels: [F_La_GetText('info-taxfree-acceder'),F_La_GetText('info-taxfree-volver')],
				animation: 'default',
				primaryButtonIndex: 1,
				cancelable: true,
				callback: function (index)
				{
					if( index == 0 )
					{
						window.location.href = "login.html";
					}
					else
					{
						var content = document.getElementById('myNavigator');
						fn.resetTo("inicio.html");
					}
				}
			});
		}
		*/
	}
	
	function F_DER_loadDERSingle( numDER )
	{
		var content = document.getElementById('myNavigator');
		var menu = document.getElementById('menu');
		var singleDER = g_arrayDERs[numDER];
		g_IdDERActual = singleDER['IdDER'];
		
		content.pushPage("derSingle.html").then( function()
		{
		  $("#tax-proceso").show();
		  
		  F_Up_GetPrefs(function()
		  {
			var dateFormat;
			
			$("#singleDER-nombre").html( singleDER['tienda']['establishment_tradename'] );
			$("#singleDER-total").html( singleDER['total_iva'].toFixed(2).toString() + "€" );
			$("#singleDER-base").html( singleDER['total_taxable_base'].toFixed(2).toString() + "€" );
			$("#singleDER-numFactura").html( singleDER['facturaNumero'] );
			$("#singleDER-fecha").html( singleDER['facturaFecha'] );
			
			$("#slingleDER-idnum").html( singleDER['invoice_number'] );
			
			$("#codeILR").html( singleDER['id_local_reference'] );
			
			dateFormat = singleDER['document_date'];
			$("#fechaTransaccion").html( dateFormat.substring(6,8) + "/" + dateFormat.substring(4,6) + "/" + dateFormat.substring(0,4) );
			
			var qrcode = new QRCode("qrcode", {
				text: singleDER['id_local_reference'],
				width: 128,
				height: 128,
				colorDark : "#000000",
				colorLight : "#ffffff",
				correctLevel : QRCode.CorrectLevel.M
			});
			
			
			$("#singleDER-nombreCalle").html( singleDER['tienda']['establishment_tradename'] );
			$("#singleDER-razonSocial").html( singleDER['tienda']['establishment_name'] );
			$("#singleDER-nifTienda").html( singleDER['tienda']['establishment_nif'] );
			
			console.log(singleDER);
			
			$("#singleDER-nombreColab").html( singleDER['declarant_name'] );
			$("#singleDER-nifColab").html( singleDER['declarant_nif'] );
			
			if( singleDER['declarant_name'] == "" ) $("#singleDER-nombreColab").parent().hide();
			if( singleDER['declarant_nif'] == "" ) $("#singleDER-nifColab").parent().hide();
			
			var formasDePago = ["Efectivo","Tarjeta","Cheque","Transferencia","Otros"];
			$("#singleDER-formaPago").html( "Pago: " + formasDePago[singleDER['payment_mode']] );
			
			$("#singleDER-nombreTurista").html( userPrefs['turista']['traveler_name'] );
			$("#singleDER-nifTurista").html( userPrefs['turista']['traveler_passport'] );
			
			/*
			dateFormat = userPrefs['turista']['traveler_birthdate'];
			$("#singleDER-fechaNacimiento").html( dateFormat.substring(6,8) + "/" + dateFormat.substring(4,6) + "/" + dateFormat.substring(0,4) );
			
			dateFormat = userPrefs['turista']['traveler_transport_arrival_date'];
			$("#singleDER-fechaLlegada").html( dateFormat.substring(6,8) + "/" + dateFormat.substring(4,6) + "/" + dateFormat.substring(0,4) );
			
			$("#singleDER-vueloLlegada").html( userPrefs['turista']['traveler_transport_arrival_number'] );
			
			dateFormat = userPrefs['turista']['traveler_transport_depart_date'];
			$("#singleDER-fechaSalida").html( dateFormat.substring(6,8) + "/" + dateFormat.substring(4,6) + "/" + dateFormat.substring(0,4) );
			
			$("#singleDER-vueloSalida").html( userPrefs['turista']['traveler_transport_depart_number'] );
			
			if( userPrefs['turista']['traveler_transport_arrival_date'] == "" ) $("#singleDER-fechaLlegada").parent().hide();
			if( userPrefs['turista']['traveler_transport_arrival_number'] == "" ) $("#singleDER-vueloLlegada").parent().hide();
			if( userPrefs['turista']['traveler_transport_depart_date'] == "" ) $("#singleDER-fechaSalida").parent().hide();
			if( userPrefs['turista']['traveler_transport_depart_number'] == "" ) $("#singleDER-vueloSalida").parent().hide();
			*/
			
			if( singleDER['estadoAEAT'] >= 1 ){ $("#estadoDER_top1").html('<ons-icon icon="fa-check" ></ons-icon>'); }
			else { $("#estadoDER_top1").html('<ons-icon icon="fa-ellipsis-h" ></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 2 ){ $("#estadoDER_top2").html('<ons-icon icon="fa-check" ></ons-icon>'); }
			else { $("#estadoDER_top2").html('<ons-icon icon="fa-ellipsis-h" ></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 3 ){ $("#estadoDER_top3").html('<ons-icon icon="fa-check" ></ons-icon>'); }
			else { $("#estadoDER_top3").html('<ons-icon icon="fa-ellipsis-h" ></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 4 ){ $("#estadoDER_top4").html('<ons-icon icon="fa-check" ></ons-icon>'); }
			else { $("#estadoDER_top4").html('<ons-icon icon="fa-ellipsis-h" ></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 1 ){ $("#estadoDER_bottom1").html('<ons-icon icon="fa-check"></ons-icon>'); }
			else { $("#estadoDER_bottom1").html('<ons-icon icon="fa-ellipsis-h"></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 2 ){ $("#estadoDER_bottom2").html('<ons-icon icon="fa-check"></ons-icon>'); }
			else { $("#estadoDER_bottom2").html('<ons-icon icon="fa-ellipsis-h"></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 3 ){ $("#estadoDER_bottom3").html('<ons-icon icon="fa-check"></ons-icon>'); }
			else { $("#estadoDER_bottom3").html('<ons-icon icon="fa-ellipsis-h"></ons-icon>'); }
			
			if( singleDER['estadoAEAT'] >= 4 ){ $("#estadoDER_bottom4").html('<ons-icon icon="fa-check"></ons-icon>'); }
			else { $("#estadoDER_bottom4").html('<ons-icon icon="fa-ellipsis-h"></ons-icon>'); }
			
			// Boton de solicitud de reembolso.
			
			if( singleDER['estadoAEAT'] == 3 )
			{
			  $('#barraVolver').hide();
			  $('#barraVolverSolicitar').show();
			  
			  if( singleDER['reembolsoSolicitado'] == 1 )
			  {
				$('#btnSolicitarPago').hide();
				$('#btnPagoSolicitado').show();
			  }
			  else
			  {
				$('#btnSolicitarPago').show();
				$('#btnPagoSolicitado').hide();
			  }
			}
		  });
		});
	}
	
	function F_Turista_SetDatosConfiguracion()
	{
		if( typeof(userPrefs['turista']['nombre']) != 'undefined' ) $('#perfil-nombre').val( userPrefs['turista']['nombre'] );
		if( typeof(userPrefs['turista']['mail']) != 'undefined' ) $('#perfil-mail').val( userPrefs['turista']['mail'] );
		if( typeof(userPrefs['turista']['fechaNacimiento']) != 'undefined' ) $('#perfil-fechaNacimiento').val( userPrefs['turista']['fechaNacimiento'] );
		if( typeof(userPrefs['turista']['paisOrigen']) != 'undefined' ) $('#perfil-paisOrigen').val( userPrefs['turista']['paisOrigen'] );
		if( typeof(userPrefs['turista']['numPasaporte']) != 'undefined' ) $('#perfil-numPasaporte').val( userPrefs['turista']['numPasaporte'] );
		if( typeof(userPrefs['turista']['fechaLlegada']) != 'undefined' ) $('#perfil-fechaLlegada').val( userPrefs['turista']['fechaLlegada'] );
		if( typeof(userPrefs['turista']['vueloLlegada']) != 'undefined' ) $('#perfil-vueloLlegada').val( userPrefs['turista']['vueloLlegada'] );
		if( typeof(userPrefs['turista']['fechaPartida']) != 'undefined' ) $('#perfil-fechaPartida').val( userPrefs['turista']['fechaPartida'] );
		if( typeof(userPrefs['turista']['vueloPartida']) != 'undefined' ) $('#perfil-vueloPartida').val( userPrefs['turista']['vueloPartida'] );
		if( typeof(userPrefs['turista']['modoReembolso']) != 'undefined' ) $('#perfil-modoReembolso').val( userPrefs['turista']['modoReembolso'] );
	}
	
	function F_Turista_EnviarDatosConfiguracion( callback )
	{
		var nombre = $('#perfil-nombre').val();
		var mail = $('#perfil-mail').val();
		var fechaNacimiento = $('#perfil-fechaNacimiento').val();
		var paisOrigen = $('#perfil-paisOrigen').val();
		var numPasaporte = $('#perfil-numPasaporte').val();
		var fechaLlegada = $('#perfil-fechaLlegada').val();
		var vueloLlegada = $('#perfil-vueloLlegada').val();
		var fechaPartida = $('#perfil-fechaPartida').val();
		var vueloPartida = $('#perfil-vueloPartida').val();
		var modoReembolso = $('#perfil-modoReembolso').val();
		
		F_Ep_EditTourist( callback );
	}
	
	// --- Áreas restringidas ---

	function F_Init_SeccionesRegistro()
	{
		if( userPrefs['loggedIn'] )
		{
			$('.seccionNoRegistrados').css('display','none');
			$('.seccionRegistrados').css('display','');
		}
		else
		{
			$('.seccionNoRegistrados').css('display','');
			$('.seccionRegistrados').css('display','none');
		}
	}

	// **************** GLOBALES ****************
	
	function formatAMPM( date )
	{
	  var hours = date.getHours();
	  var minutes = date.getMinutes();
	  var ampm = hours >= 12 ? 'pm' : 'am';
	  hours = hours % 12;
	  hours = hours ? hours : 12; // the hour '0' should be '12'
	  minutes = minutes < 10 ? '0'+minutes : minutes;
	  var strTime = hours + ':' + minutes + ' <strong>' + ampm + '</strong>';
	  return strTime;
	}
	
	// Email validation over RegEx
	function validateEmail(email)
	{
	  var re = /^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
	  return re.test(email);
	}
	
	// Passport validation over RegEx
	function F_G_validatePassport( passport )
	{
	  var re = /^(?!^0+$)[a-zA-Z0-9]{3,20}$/;
	  
	  if( re.test(passport) )
	  {
		$('#iconoValidacionPasaporte').addClass('fa-check');
		$('#iconoValidacionPasaporte').removeClass('fa-times');
		$('#iconoValidacionPasaporte').css('color','#33CC22');
	  }
	  else
	  {
		$('#iconoValidacionPasaporte').removeClass('fa-check');
		$('#iconoValidacionPasaporte').addClass('fa-times');
		$('#iconoValidacionPasaporte').css('color','#CC3344');
	  }
	}
	
