
//_____________________ Funciones de transición __________________

// --- ComerciosCategoria ---

function N_Push_Comercios()
{
	nav.pushPage('comercios.html');
}

function N_Init_Comercios()
{
	$('#tituloNav-comercios').html( F_La_GetText('titulo-comercios') );
	
	// Randomizar un Array
	function shuffle(a)
	{
		for (let i = a.length - 1; i > 0; i--) {
			const j = Math.floor(Math.random() * (i + 1));
			[a[i], a[j]] = [a[j], a[i]];
		}
		return a;
	}
	
	// Obtenemos tiendas aleatorias de cada categoria
	for( let i=1 ; i<=10 ; i++ )
	{
		$('#comercios_titulo_' + i).html( g_categorias[i]['nombre'] );
		
		var arrayMezclado = shuffle( g_tiendasCategoria[i] );
		
		for( let j=1 ; j<=5 ; j++ )
		{ 
			var indiceTiendaRandom = arrayMezclado[((j-1)%arrayMezclado.length)];
			
			$('#comercios_' + i + '_carousel_' + j + ' .carouselNombreTienda').html( g_tiendas[indiceTiendaRandom]['name'] );
			$('#comercios_' + i + '_carousel_' + j + ' .title').parent().attr( 'onclick', 'N_Push_ComercioSingle( ' + indiceTiendaRandom + ' );' );
			$('#comercios_' + i + '_carousel_' + j + ' .card').css( 'background-size','cover' );
			$('#comercios_' + i + '_carousel_' + j + ' .card').css( 'background-image','url(' + g_tiendas[indiceTiendaRandom]['img'] + ')' );
		}
	}
}

function N_Push_ComerciosCategoria( numCategoria )
{
	p_categoria = g_categorias[numCategoria];
	nav.pushPage('comerciosCategoria.html');
}

function N_Init_ComerciosCategoria()
{
	$('#comerciosCategoria_titulo').html( p_categoria['nombre'] );
	
	var div = document.getElementById("map_canvas_categoria");
	var markers = [];
	var markerCluster;
	//var bounds = new plugin.google.maps.LatLngBounds();
	
	for( let i=0 ; i<g_tiendasCategoria[p_categoria['id']].length ; i++ )
	{
		var idTienda = g_tiendasCategoria[p_categoria['id']][i];
		var myTienda = g_tiendas[idTienda];
		
		$("#comerciosCategoria_lista").append("<ons-list-item onclick='N_Push_ComercioSingle(" + idTienda + ")'>  \
												  <div class='left'>                                                      						  \
													<img class='list-item__thumbnail' src='" + myTienda['logo_img'] + "'> 						  \
												  </div>                                                                  						  \
												  <div class='center'>                                                    						  \
													<span class='list-item__title'>" + myTienda['name'] + "</span>		  						  \
													<span class='list-item__subtitle'>" + myTienda['address'] + "</span>  						  \
												  </div>                                                                  						  \
												</ons-list-item>");
		
		if( parseFloat(myTienda['gps_lat']) != NaN && parseFloat(myTienda['gps_lon']) != NaN && myTienda['name'] != "" && myTienda['address'] != "" )
		{
			markers.push({
				'indice': idTienda,
				'position': {'lat': parseFloat(myTienda['gps_lat']), 'lng': parseFloat(myTienda['gps_lon'])},
				'title': myTienda['name'],
				'snippet': myTienda['address'],
				'icon': imgMarkers['marker']
			});
			
			//bounds.extend( {lat: myTienda['gps_lat'], lng: myTienda['gps_lon']} );
		}
	}
	
	// ___ Init vista Mapa ___
	
	plugin.google.maps.environment.setEnv({
		'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
		'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	// Create a Google Maps native view under the map_canvas_categoria div.
	var map = plugin.google.maps.Map.getMap(div,
	{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': false,
		'rotate': false,
		'zoom': true
	  },
	  'camera': {
        'target': {'lat': parseFloat(myTienda['gps_lat']), 'lng': parseFloat(myTienda['gps_lon'])},
        'zoom': 15
      }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var labelOptions = {
		  bold: true,
		  fontSize: 16,
		  color: "black",
		  italic: false
		};
		
		markerCluster = map.addMarkerCluster({
		  'debug': false,
		  //'maxZoomLevel': 15,
		  'boundsDraw': false,
		  'markers': markers,
		  'icons': [
			  //{min: 2, max: 30, url: "./img/cluster/pin1_75.png", anchor: {x: 32, y: 30}, label: labelOptions},
			  {min: 2, max: 20, url: imgMarkers['clusterBlue'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 20, max: 40, url: imgMarkers['clusterYellow'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 40, max: 60, url: imgMarkers['clusterRed'], anchor: {x: 24, y: 24}, label: labelOptions},
			  {min: 60, url: imgMarkers['clusterPurple'], anchor: {x: 24, y: 24}, label: labelOptions}
		  ]
		});
		
		markerCluster.on(plugin.google.maps.event.MARKER_CLICK, function (position, marker)
		{
			var indiceTienda = marker.get("indice");
			
			var categoriaTienda = 2;
			
			$('#comerciosCategoria_preview').fadeIn(150);
			$('#comerciosCategoria_preview .center').click(function(){ N_Push_ComercioSingle( marker.get("indice") ); });
			
			// Fondo
			$('#comerciosCategoria_preview ons-row').css('background-image',"url('" + g_tiendas[indiceTienda]['img'] + "')");
			$('#comerciosCategoria_preview ons-row').css('background-size',"cover");
			
			// Logo central
			$('#comerciosCategoria_preview .center img').attr('src',g_tiendas[indiceTienda]['logo_img']);
			
			// Img categoria
			$('#comerciosCategoria_preview .left img').attr('src',"img/categorias/" + categoriaTienda + "-azul.png");
			
			//N_Push_ComercioSingle(marker.get("indice"));
		});
		
		//map.animateCamera({
		//	'target' : bounds
		//});
	});
}

// --- Actividades ---

function N_Push_Actividades()
{
	nav.pushPage('actividades.html');
}

function N_Init_Actividades()
{
	$('#actividades_titulo').html( F_La_GetText('titulo-actividades') );
	
	var div = document.getElementById("actividades_map_canvas");
	var markers = [];
	var markerCluster;
	//var bounds = new plugin.google.maps.LatLngBounds();
	
	for( let i=0 ; i<g_actividades.length ; i++ )
	{
		var myActividad = g_actividades[i];
		
		$("#actividades_lista").append("<ons-list-item onclick='N_Push_ActividadSingle(" + i + ")'> 				 \
										  <div class='left'>                                                      	 \
											<img class='list-item__thumbnail' src='" + myActividad['logo_img'] + "'> \
										  </div>                                                                  	 \
										  <div class='center'>                                                    	 \
											<span class='list-item__title'>" + myActividad['name'] + "</span>		 \
											<span class='list-item__subtitle'>" + myActividad['address'] + "</span>  \
										  </div>                                                                  	 \
										</ons-list-item>");
		
		if( parseFloat(myActividad['gps_lat']) != NaN && parseFloat(myActividad['gps_lon']) != NaN && myActividad['name'] != "" && myActividad['address'] != "" )
		{
			markers.push({
				'indice': i,
				'position': {'lat': parseFloat(myActividad['gps_lat']), 'lng': parseFloat(myActividad['gps_lon'])},
				'title': myActividad['name'],
				'snippet': myActividad['address'],
				'icon': imgMarkers['marker']
			});
			
			//bounds.extend( {lat: myActividad['gps_lat'], lng: myActividad['gps_lon']} );
		}
	}
	
	// ___ Init vista Mapa ___
	
	plugin.google.maps.environment.setEnv({
		'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
		'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	// Create a Google Maps native view under the actividades_map_canvas div.
	var map = plugin.google.maps.Map.getMap(div,
	{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': false,
		'rotate': false,
		'zoom': true
	  },
	  'camera': {
        'target': {'lat': parseFloat(myActividad['gps_lat']), 'lng': parseFloat(myActividad['gps_lon'])},
        'zoom': 15
      }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var labelOptions = {
		  bold: true,
		  fontSize: 16,
		  color: "black",
		  italic: false
		};
		
		markerCluster = map.addMarkerCluster({
		  'debug': false,
		  //'maxZoomLevel': 15,
		  'boundsDraw': false,
		  'markers': markers,
		  'icons': [
			  //{min: 2, max: 30, url: "./img/cluster/pin1_75.png", anchor: {x: 32, y: 30}, label: labelOptions},
			  {min: 2, max: 20, url: imgMarkers['clusterBlue'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 20, max: 40, url: imgMarkers['clusterYellow'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 40, max: 60, url: imgMarkers['clusterRed'], anchor: {x: 24, y: 24}, label: labelOptions},
			  {min: 60, url: imgMarkers['clusterPurple'], anchor: {x: 24, y: 24}, label: labelOptions}
		  ]
		});
		
		markerCluster.on(plugin.google.maps.event.MARKER_CLICK, function (position, marker)
		{
			var indiceActividad = marker.get("indice");
			
			var categoriaTienda = 10;
			
			$('#actividades_preview').fadeIn(150);
			$('#actividades_preview .center').click(function(){ N_Push_ActividadSingle( marker.get("indice") ); });
			
			// Fondo
			$('#actividades_preview ons-row').css('background-image',"url('" + g_actividades[indiceActividad]['img'] + "')");
			$('#actividades_preview ons-row').css('background-size',"cover");
			
			// Logo central
			$('#actividades_preview .center img').attr('src',g_actividades[indiceActividad]['logo_img']);
			
			// Img categoria
			$('#actividades_preview .left img').attr('src',"img/categorias/" + categoriaTienda + "-azul.png");
		});
		
		//map.animateCamera({
		//	'target' : bounds
		//});
	});
}

// --- Servicios ---

function N_Push_Servicios()
{
	nav.pushPage('servicios.html');
}

function N_Init_Servicios()
{
	$('#servicios_titulo').html( F_La_GetText('titulo-servicios') );
	
	var div = document.getElementById("servicios_map_canvas");
	var markers = [];
	var markerCluster;
	//var bounds = new plugin.google.maps.LatLngBounds();
	
	for( let i=0 ; i<g_servicios.length ; i++ )
	{
		var myServicio = g_servicios[i];
		
		$("#servicios_lista").append("<ons-list-item onclick='N_Push_ServicioSingle(" + i + ")'> 					\
										  <div class='left'>                                                      	\
											<img class='list-item__thumbnail' src='" + myServicio['logo_img'] + "'> \
										  </div>                                                                  	\
										  <div class='center'>                                                    	\
											<span class='list-item__title'>" + myServicio['name'] + "</span>		\
											<span class='list-item__subtitle'>" + myServicio['address'] + "</span>  \
										  </div>                                                                  	\
										</ons-list-item>");
		
		if( parseFloat(myServicio['gps_lat']) != NaN && parseFloat(myServicio['gps_lon']) != NaN && myServicio['name'] != "" && myServicio['address'] != "" )
		{
			markers.push({
				'indice': i,
				'position': {'lat': parseFloat(myServicio['gps_lat']), 'lng': parseFloat(myServicio['gps_lon'])},
				'title': myServicio['name'],
				'snippet': myServicio['address'],
				'icon': imgMarkers['marker']
			});
			
			//bounds.extend( {lat: myServicio['gps_lat'], lng: myServicio['gps_lon']} );
		}
	}
	
	// ___ Init vista Mapa ___
	
	plugin.google.maps.environment.setEnv({
		'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
		'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	// Create a Google Maps native view under the actividades_map_canvas div.
	var map = plugin.google.maps.Map.getMap(div,
	{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': false,
		'rotate': false,
		'zoom': true
	  },
	  'camera': {
        'target': {'lat': parseFloat(myServicio['gps_lat']), 'lng': parseFloat(myServicio['gps_lon'])},
        'zoom': 15
      }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var labelOptions = {
		  bold: true,
		  fontSize: 16,
		  color: "black",
		  italic: false
		};
		
		markerCluster = map.addMarkerCluster({
		  'debug': false,
		  //'maxZoomLevel': 15,
		  'boundsDraw': false,
		  'markers': markers,
		  'icons': [
			  //{min: 2, max: 30, url: "./img/cluster/pin1_75.png", anchor: {x: 32, y: 30}, label: labelOptions},
			  {min: 2, max: 20, url: imgMarkers['clusterBlue'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 20, max: 40, url: imgMarkers['clusterYellow'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 40, max: 60, url: imgMarkers['clusterRed'], anchor: {x: 24, y: 24}, label: labelOptions},
			  {min: 60, url: imgMarkers['clusterPurple'], anchor: {x: 24, y: 24}, label: labelOptions}
		  ]
		});
		
		markerCluster.on(plugin.google.maps.event.MARKER_CLICK, function (position, marker)
		{
			var indiceServicio = marker.get("indice");
			
			var categoriaTienda = 10;
			
			$('#servicios_preview').fadeIn(150);
			$('#servicios_preview .center').click(function(){ N_Push_ServicioSingle( marker.get("indice") ); });
			
			// Fondo
			$('#servicios_preview ons-row').css('background-image',"url('" + g_servicios[indiceServicio]['img'] + "')");
			$('#servicios_preview ons-row').css('background-size',"cover");
			
			// Logo central
			$('#servicios_preview .center img').attr('src',g_servicios[indiceServicio]['logo_img']);
			
			// Img categoria
			$('#servicios_preview .left img').attr('src',"img/categorias/" + categoriaTienda + "-azul.png");
		});
		
		//map.animateCamera({
		//	'target' : bounds
		//});
	});
	
}

// --- Rutas ---

function N_Push_Rutas()
{
	//$('.page__background[__plugindomid]').css('background-color','rgba(0,0,0,0) !important;');
	nav.pushPage('rutas.html');
}

function N_Init_Rutas()
{
	$('#tituloNav-rutas').html( F_La_GetText('titulo-rutas') );
	
	// Obtenemos tiendas aleatorias de cada categoria
	for( let i=1 ; i<=8 ; i++ )
	{
		$('#rutas_titulo_' + i).html( g_rutas[i]['nombre'] );
	}
}

// --- ComercioSingle ---

var markerUser;
var myLocation;
var myPolyline;
var map;

function N_Push_ComercioSingle( numComercio )
{
	p_comercioSingle = g_tiendas[numComercio];
	nav.pushPage('comercioSingle.html');
}

function N_Init_ComercioSingle()
{
	var latLngTienda = {"lat":parseFloat(p_comercioSingle['gps_lat']),"lng":parseFloat(p_comercioSingle['gps_lon'])};
	
	var linkTienda;
	if( p_comercioSingle['url'] != '' && p_comercioSingle['url'] != '-' ) linkTienda = '<a target="_blank" href="' + p_comercioSingle['url'] + '">' + p_comercioSingle['name'] + '</a>';
	else linkTienda = 'N/A';
	
	var linkTelefono;
	if( p_comercioSingle['telephone'] != '' && p_comercioSingle['telephone'] != '-' ) linkTelefono = '<a target="_blank" href="tel:' + p_comercioSingle['telephone'] + '">' + p_comercioSingle['telephone'] + '</a>';
	else linkTelefono = 'N/A';
	
	$('#comercioSingle_titulo').html( p_comercioSingle['name'] );
	$('#comercioSingle_imgBackground').css( 'background-image', 'url(' + p_comercioSingle['img'] + ')' );
	$('#comercioSingle_logo').attr( 'src', p_comercioSingle['logo_img'] );
	
	$('#comercioSingle_direccion').html( p_comercioSingle['address'] );
	$('#comercioSingle_horario').html( p_comercioSingle['opening_hours_' + F_La_GetCodIdiomaJSON()] );
	$('#comercioSingle_telefono').html( linkTelefono );
	$('#comercioSingle_web').html( linkTienda );
	$('#comercioSingle_descripcion').html( p_comercioSingle['description_' + F_La_GetCodIdiomaJSON()] );
	
	plugin.google.maps.environment.setEnv({
	  'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
	  'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	var div = document.getElementById("comercio_map_canvas_single");
	
    // Create a Google Maps native view under the comercio_map_canvas_single div.
    map = plugin.google.maps.Map.getMap(div,{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': true,
		'rotate': true,
		'zoom': true
	  },
	  'camera': {
		'latLng': latLngTienda,
		'tilt': 30,
		'zoom': 18
	  }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var locationRef = {
			lat: parseFloat(p_comercioSingle['gps_lat']),
			lng: parseFloat(p_comercioSingle['gps_lon'])
		};
		
		// Add a maker
		var marker = map.addMarker({
		  position: locationRef,
		  animation: plugin.google.maps.Animation.BOUNCE,
		  'icon': imgMarkers['marker']
		});
		
		// --- Geolocalizacion ---
		
		$('#btnGeolocalizar').click(function()
		{
			Geolocalizar( map, locationRef, function(){} );
		});
		
		$('.btnRuta').click(function()
		{
			var mode;
			
			if( $(this).attr('data-tipoRuta') == "WALKING" ) mode = google.maps.TravelMode.WALKING;
			else if( $(this).attr('data-tipoRuta') == "TRANSIT" ) mode = google.maps.TravelMode.TRANSIT;
			else if( $(this).attr('data-tipoRuta') == "DRIVING" ) mode = google.maps.TravelMode.DRIVING;
			
			if( typeof(g_userLocation) == 'undefined' )
			{
				Geolocalizar( map, locationRef, function(){ CalcularRuta( map, mode, latLngTienda ); } );
			}
			else
			{
				CalcularRuta( map, mode, latLngTienda );
			}
		});
	});
}

// --- ActividadSingle ---

function N_Push_ActividadSingle( numActividad )
{
	p_actividadSingle = g_actividades[numActividad];
	nav.pushPage('actividadSingle.html');
}

function N_Init_ActividadSingle()
{
	var myLocation;
	var myPolyline;
	var latLngTienda = {"lat":parseFloat(p_actividadSingle['gps_lat']),"lng":parseFloat(p_actividadSingle['gps_lon'])};
	var g_procesandoRuta = false;
	
	var linkTienda;
	if( p_actividadSingle['url'] != '' && p_actividadSingle['url'] != '-' ) linkTienda = '<a target="_blank" href="' + p_actividadSingle['url'] + '">' + p_actividadSingle['name'] + '</a>';
	else linkTienda = 'N/A';
	
	var linkTelefono;
	if( p_actividadSingle['telephone'] != '' && p_actividadSingle['telephone'] != '-' ) linkTelefono = '<a target="_blank" href="tel:' + p_actividadSingle['telephone'] + '">' + p_actividadSingle['telephone'] + '</a>';
	else linkTelefono = 'N/A';
	
	$('#actividadSingle_titulo').html( p_actividadSingle['name'] );
	$('#actividadSingle_imgBackground').css( 'background-image', 'url(' + p_actividadSingle['img'] + ')' );
	$('#actividadSingle_logo').attr( 'src', p_actividadSingle['logo_img'] );
	
	$('#actividadSingle_direccion').html( p_actividadSingle['address'] );
	$('#actividadSingle_horario').html( p_actividadSingle['opening_hours_' + F_La_GetCodIdiomaJSON()] );
	$('#actividadSingle_telefono').html( linkTelefono );
	$('#actividadSingle_web').html( linkTienda );
	$('#actividadSingle_descripcion').html( p_actividadSingle['description_' + F_La_GetCodIdiomaJSON()] );
	
	plugin.google.maps.environment.setEnv({
	  'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
	  'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	var div = document.getElementById("actividad_map_canvas_single");
	
    // Create a Google Maps native view under the actividad_map_canvas_single div.
    var map = plugin.google.maps.Map.getMap(div,{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': true,
		'rotate': true,
		'zoom': true
	  },
	  'camera': {
		'latLng': latLngTienda,
		'tilt': 30,
		'zoom': 18
	  }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var locationRef = {
			lat: parseFloat(p_actividadSingle['gps_lat']),
			lng: parseFloat(p_actividadSingle['gps_lon'])
		};
		
		// Add a maker
		var marker = map.addMarker({
		  position: locationRef,
		  animation: plugin.google.maps.Animation.BOUNCE,
		  'icon': imgMarkers['marker']
		});
		
		// --- Geolocalizacion ---
		
		$('#btnGeolocalizar').click(function()
		{
			Geolocalizar( map, locationRef, function(){} );
		});
		
		$('.btnRuta').click(function()
		{
			var mode;
			
			if( $(this).attr('data-tipoRuta') == "WALKING" ) mode = google.maps.TravelMode.WALKING;
			else if( $(this).attr('data-tipoRuta') == "TRANSIT" ) mode = google.maps.TravelMode.TRANSIT;
			else if( $(this).attr('data-tipoRuta') == "DRIVING" ) mode = google.maps.TravelMode.DRIVING;
			
			if( typeof(g_userLocation) == 'undefined' )
			{
				Geolocalizar( map, locationRef, function(){ CalcularRuta( map, mode, latLngTienda ); } );
			}
			else
			{
				CalcularRuta( map, mode, latLngTienda );
			}
		});
	});
}

// --- ServicioSingle ---
 
function N_Push_ServicioSingle( numServicio )
{
	p_servicioSingle = g_servicios[numServicio];
	nav.pushPage('servicioSingle.html');
}

function N_Init_ServicioSingle()
{
	var myLocation;
	var myPolyline;
	var latLngTienda = {"lat":parseFloat(p_servicioSingle['gps_lat']),"lng":parseFloat(p_servicioSingle['gps_lon'])};
	var g_procesandoRuta = false;
	
	var linkTienda;
	if( p_servicioSingle['url'] != '' && p_servicioSingle['url'] != '-' ) linkTienda = '<a target="_blank" href="' + p_servicioSingle['url'] + '">' + p_servicioSingle['name'] + '</a>';
	else linkTienda = 'N/A';
	
	var linkTelefono;
	if( p_servicioSingle['telephone'] != '' && p_servicioSingle['telephone'] != '-' ) linkTelefono = '<a target="_blank" href="tel:' + p_servicioSingle['telephone'] + '">' + p_servicioSingle['telephone'] + '</a>';
	else linkTelefono = 'N/A';
	
	$('#servicioSingle_titulo').html( p_servicioSingle['name'] );
	$('#servicioSingle_imgBackground').css( 'background-image', 'url(' + p_servicioSingle['img'] + ')' );
	$('#servicioSingle_logo').attr( 'src', p_servicioSingle['logo_img'] );
	
	$('#servicioSingle_direccion').html( p_servicioSingle['address'] );
	$('#servicioSingle_horario').html( p_servicioSingle['opening_hours_' + F_La_GetCodIdiomaJSON()] );
	$('#servicioSingle_telefono').html( linkTelefono );
	$('#servicioSingle_web').html( linkTienda );
	$('#servicioSingle_descripcion').html( p_servicioSingle['description_' + F_La_GetCodIdiomaJSON()] );
	
	plugin.google.maps.environment.setEnv({
	  'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
	  'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	var div = document.getElementById("servicio_map_canvas_single");
	
    // Create a Google Maps native view under the servicio_map_canvas_single div.
    var map = plugin.google.maps.Map.getMap(div,{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': true,
		'rotate': true,
		'zoom': true
	  },
	  'camera': {
		'latLng': latLngTienda,
		'tilt': 30,
		'zoom': 18
	  }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var locationRef = {
			lat: parseFloat(p_servicioSingle['gps_lat']),
			lng: parseFloat(p_servicioSingle['gps_lon'])
		};
		
		// Add a maker
		var marker = map.addMarker({
		  position: locationRef,
		  animation: plugin.google.maps.Animation.BOUNCE,
		  'icon': imgMarkers['marker']
		});
		
		// --- Geolocalizacion ---
		
		$('#btnGeolocalizar').click(function()
		{
			Geolocalizar( map, locationRef, function(){} );
		});
		
		$('.btnRuta').click(function()
		{
			var mode;
			
			if( $(this).attr('data-tipoRuta') == "WALKING" ) mode = google.maps.TravelMode.WALKING;
			else if( $(this).attr('data-tipoRuta') == "TRANSIT" ) mode = google.maps.TravelMode.TRANSIT;
			else if( $(this).attr('data-tipoRuta') == "DRIVING" ) mode = google.maps.TravelMode.DRIVING;
			
			if( typeof(g_userLocation) == 'undefined' )
			{
				Geolocalizar( map, locationRef, function(){ CalcularRuta( map, mode, latLngTienda ); } );
			}
			else
			{
				CalcularRuta( map, mode, latLngTienda );
			}
		});
	});
}

// --- RutaSingle ---

function N_Push_RutaSingle( indiceRuta )
{
	p_rutaSingle = g_rutas[indiceRuta];
	nav.pushPage('rutaSingle.html');
}

function N_Init_RutaSingle()
{
	$('#rutaSingle_titulo').html( p_rutaSingle['nombre'] );
	
	var div = document.getElementById("rutaSingle_map_canvas");
	var markers = [];
	var markerCluster;
	//var bounds = new plugin.google.maps.LatLngBounds();
	
	for( let i=0 ; i<g_tiendasRuta[p_rutaSingle['id']].length ; i++ )
	{
		var idTienda = g_tiendasRuta[p_rutaSingle['id']][i];
		var myTienda = g_tiendas[idTienda];
		
		console.log( idTienda );
		
		$("#rutaSingle_lista").append("<ons-list-item onclick='N_Push_ComercioSingle(" + g_tiendasRuta[p_rutaSingle['id']][i] + ")'> \
												  <div class='left'>                                                      				 \
													<img class='list-item__thumbnail' src='" + myTienda['logo_img'] + "'> 				 \
												  </div>                                                                  				 \
												  <div class='center'>                                                    				 \
													<span class='list-item__title'>" + myTienda['name'] + "</span>		  				 \
													<span class='list-item__subtitle'>" + myTienda['address'] + "</span>  				 \
												  </div>                                                                  				 \
												</ons-list-item>");
		
		if( parseFloat(myTienda['gps_lat']) != NaN && parseFloat(myTienda['gps_lon']) != NaN && myTienda['name'] != "" && myTienda['address'] != "" )
		{
			markers.push({
				'indice': idTienda,
				'position': {'lat': parseFloat(myTienda['gps_lat']), 'lng': parseFloat(myTienda['gps_lon'])},
				'title': myTienda['name'],
				'snippet': myTienda['address'],
				'icon': imgMarkers['marker']
			});
			
			//bounds.extend( {lat: myTienda['gps_lat'], lng: myTienda['gps_lon']} );
		}
	}
	
	// ___ Init vista Mapa ___
	
	plugin.google.maps.environment.setEnv({
		'API_KEY_FOR_BROWSER_RELEASE': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98',
		'API_KEY_FOR_BROWSER_DEBUG': 'AIzaSyB0qe9jlah0VWboK3Mx2yxE84EFNFkVb98'  // optional
	});
	
	// Create a Google Maps native view under the rutaSingle_map_canvas div.
	var map = plugin.google.maps.Map.getMap(div,
	{
	  'backgroundColor': 'white',
	  //'mapType': plugin.google.maps.MapTypeId.HYBRID,
	  'controls': {
		'compass': true,
		'myLocationButton': true,
		'indoorPicker': true,
		'zoom': true
	  },
	  'gestures': {
		'scroll': true,
		'tilt': false,
		'rotate': false,
		'zoom': true
	  },
	  'camera': {
        'target': {'lat': parseFloat(myTienda['gps_lat']), 'lng': parseFloat(myTienda['gps_lon'])},
        'zoom': 15
      }
	});
	
	map.on(plugin.google.maps.event.MAP_READY, function()
	{
		var labelOptions = {
		  bold: true,
		  fontSize: 16,
		  color: "black",
		  italic: false
		};
		
		markerCluster = map.addMarkerCluster({
		  'debug': false,
		  //'maxZoomLevel': 15,
		  'boundsDraw': false,
		  'markers': markers,
		  'icons': [
			  //{min: 2, max: 30, url: "./img/cluster/pin1_75.png", anchor: {x: 32, y: 30}, label: labelOptions},
			  {min: 2, max: 20, url: imgMarkers['clusterBlue'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 20, max: 40, url: imgMarkers['clusterYellow'], anchor: {x: 16, y: 16}, label: labelOptions},
			  {min: 40, max: 60, url: imgMarkers['clusterRed'], anchor: {x: 24, y: 24}, label: labelOptions},
			  {min: 60, url: imgMarkers['clusterPurple'], anchor: {x: 24, y: 24}, label: labelOptions}
		  ]
		});
		
		markerCluster.on(plugin.google.maps.event.MARKER_CLICK, function (position, marker)
		{
			var indiceTienda = marker.get("indice");
			
			var categoriaTienda = 2;
			
			$('#rutaSingle_preview').fadeIn(150);
			$('#rutaSingle_preview .center').click(function(){ N_Push_ComercioSingle( marker.get("indice") ); });
			
			// Fondo
			$('#rutaSingle_preview ons-row').css('background-image',"url('" + g_tiendas[indiceTienda]['img'] + "')");
			$('#rutaSingle_preview ons-row').css('background-size',"cover");
			
			// Logo central
			$('#rutaSingle_preview .center img').attr('src',g_tiendas[indiceTienda]['logo_img']);
			
			// Img categoria
			$('#rutaSingle_preview .left img').attr('src',"img/categorias/" + categoriaTienda + "-azul.png");
		});
		
		//map.animateCamera({
		//	'target' : bounds
		//});
	});
}

// --- InformacionSingle ---

function N_Push_InformacionSingle( indiceInformacion )
{
	p_informacionSingle = indiceInformacion;
	
	nav.pushPage('informacionSingle.html');
}

function N_Init_InformacionSingle()
{
	$('#informacionSingle_titulo').html( F_La_GetText('info-' + p_informacionSingle + '-titulo') );
	$('#informacionSingle_contenido').html( F_La_GetText('info-' + p_informacionSingle + '-contenido') );
}

// --- InformacionSingle ---

function N_Push_Registro()
{
	nav.pushPage('registro.html');
}

function N_Init_Registro()
{
	$('#tituloNav-registro').html( F_La_GetText('titulo-registro') );
	
	var date = new Date();
	
	$('#in_reg_f_entrada').val(date.toJSON().substr(0,10));
	$('#in_reg_f_salida').val(date.toJSON().substr(0,10));
}
// ---
